#include <iostream>
#include <vector>
#include <deque>

int main()
{
    int N;
    int64_t K;
    std::cin >> N >> K;
    std::vector<int> parent(N);
    std::vector<std::vector<int> > children(N);
    parent[0] = -1;
    std::vector<int64_t> constraints(N);
    std::vector<std::vector<int> > edges(N);
    for(int i=0; i<N; i++)
    {
        std::cin >> constraints[i];
    }        
    
    for(int i=0; i<N-1; i++)
    {
        int a, b;
        std::cin >> a >> b;
        edges[a-1].push_back(b-1);
        edges[b-1].push_back(a-1);
    }
    
    std::vector<int64_t> capacity(N);

    std::deque<int> q;
    std::vector<bool> visited(N);
    q.push_back(0);
    visited[0] = true;
    while(!q.empty())
    {
        int next = q.front();
        q.pop_front();
        capacity[next] = K;
        if(constraints[next] != -1)
            capacity[next] -= constraints[next];
        for(auto it : edges[next])
        {
            if(!visited[it])
            {
                visited[it] = true;
                parent[it] = next;
                children[next].push_back(it);
                q.push_back(it);
                if(constraints[it] != -1)
                    capacity[next] -= constraints[it];
            }
        }
    }

    for(int i=0; i<N; i++)
    {
        if(capacity[i] < 0)
        {
            std::cout << "-1" << std::endl;
            return 0;
        }
    }
    
    std::vector<int> valences(N);    
    for(int i=0; i<N; i++)
    {
        valences[i] = children[i].size();
        if(valences[i] == 0) q.push_back(i);
    }

    while(!q.empty())
    {
        int next = q.front();
        q.pop_front();
        if(parent[next] != -1)
        {
            valences[parent[next]]--;
            if(valences[parent[next]]==0)
                q.push_back(parent[next]);
        }
        
        if(constraints[next] != -1)
            continue;
            
        int64_t toadd = capacity[next];
        if(parent[next] != -1)
            toadd = std::min(toadd, capacity[parent[next]]);
        constraints[next] = toadd;
        if(parent[next] != -1)
            capacity[parent[next]] -= toadd;        
            
 //       std::cout << next << " " << constraints[next] << std::endl;
        
    }   
    
    int64_t sum = 0;
    for(int i=0; i<N; i++)
        sum += constraints[i];
    std::cout << sum << std::endl;
} 
