#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

bool dfs(int cur, int par, int k, vector<vector<int>>& edges, vector<ll>& set_vals, vector<ll>& new_vals){
    for(int c: edges[cur]){
        if(c == par) continue;
        bool result = dfs(c, cur, k, edges, set_vals, new_vals);
        if(!result) return result;
    }
    ll remaining = k;

    if(set_vals[cur] != -1){
        remaining-=set_vals[cur];
    }
    // invariant: new_vals[child] = x means that it can take any value from 0 to x
    // first, go through all the set vals
    for(int c: edges[cur]){
        if(c == par) continue;
        if(set_vals[c] != -1) remaining-=set_vals[c];
    }
    if(remaining < 0) return false;

    // next, assign as much as we can to each child
    for(int c: edges[cur]){
        if(c == par) continue;
        if(set_vals[c] == -1){
            if(new_vals[c] <= remaining){
                remaining-=new_vals[c];
            }else{
                new_vals[c] = remaining;
                remaining = 0;
            }
        }
    }

    // finally, if we still have value left, give it to the parent if we can
    if(set_vals[cur] == -1){
        new_vals[cur] = remaining;
    }else{
        new_vals[cur] = set_vals[cur];
    }

    return true;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    ll k;
    cin >> n >> k;
    vector<ll> vals(n+1);

    for(int i = 0; i < n; i++){
        ll tmp;
        cin >> tmp;
        vals[i+1] = tmp;
    }
    vector<vector<int>> edges(n+1);
    for(int i = 0; i <= n; i++) edges.push_back(vector<int>());
    for(int i = 0; i < n-1; i++){
        int a, b;
        cin >> a >> b;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    vector<ll> new_vals(n+1);
    bool result = dfs(1, -1, k, edges, vals, new_vals);
    if(!result){
        cout << -1 << "\n";
    }else{
        ll tot = 0;
        for(ll val: new_vals) tot+=val;
        cout << tot << "\n";
    }
}